/* Batch Master -- module 3: parse command */

#include "batm.h"

/* Note -- both Microsoft and Borland compilers have some problems
 *  with this kind of command parsing.  Ignore warnings the compiler
 *  emits for this module.  It will work if you don't add any typos
 */

#define fn_count 16							/* Number of commands		 */

char *fn_name[fn_count] =					/* Valid commands				 */
{	"ask",		"ask@",		"beep",		"box",
	"cls",		"color",		"dec",		"delay",
	"inc",		"reptchar",	"say",		"say@",
	"skipline",	"type",		"typechar",	"wait" };

void (*routine[fn_count]) =				/* Pointers to routines 	 */
{	ask,			ask_at,		beep,			box,
	cls,			color,		dec,			dlay,
	inc,			reptchar,	say,			say_at,
	skpline,		type,			typechar,	wait };

void one_line(int argc, char *argv[])
{
	int fn;
	void (*func)(int argc, char *argv[]);

	strlwr(argv[1]);
	for (fn = 0; fn < fn_count; fn++)
		if (!strcmp(fn_name[fn], argv[1]))	/* Find matching command */
			break;
	if (fn == fn_count)
		return;										/* Leave if no match		 */
	func = routine[fn];							/* Copy pointer to temp	 */
	(*func)(argc, argv);							/* Call via function ptr */
}
