/* C language version of FREE */
/* Written for MSC 5.0, QC 2.0, and Turbo C 2.0 */

#include <stdio.h>
#include <dos.h>
#include <ctype.h>

void get_default_drive(void);
void get_drive_info(void);
void get_memory_info(void);

extern unsigned int _psp;
int drive;
union REGS reg;

void main(int argc, char *argv[])
{
   if(argc == 1)
      get_default_drive();
   else
      {
      if (argv[1][1] == ':')
         drive = toupper(argv[1][0]) - 'A' + 1;
      else
         drive = -1;
      }
   get_drive_info();
   get_memory_info();
}

void get_default_drive(void)
{
   reg.h.ah = 0x19;        /* DOS func. 19h: get current disk */
   intdos(&reg, &reg);
   drive = reg.h.al + 1;
}

void get_drive_info(void)
{
   long cluster_size, total_bytes, free_bytes;
   
   reg.h.ah = 0x36;        /* DOS func. 36h: Get drive info */
   reg.h.dl = (char) drive;
   intdos(&reg, &reg);
   if (reg.x.ax == 0xffff)
      puts("Invalid drive");
   else
      {
      cluster_size = (long) reg.x.ax * (long) reg.x.cx;
      total_bytes  = (long) reg.x.dx * cluster_size;
      free_bytes   = (long) reg.x.bx * cluster_size;
      printf("\nDrive %c:",drive + 'A' - 1);
      printf("\n  %9lu bytes total disk space",total_bytes);
      printf("\n  %9lu bytes available on disk\n",free_bytes);
      }
}

void get_memory_info()
{
   long mem_size;             /* in paragraphs */

   int86(0x12, &reg, &reg);
   mem_size = reg.x.ax * 64;
   
   printf("\n  %9lu bytes total memory",(long) reg.x.ax * 1024L);
   printf("\n  %9lu bytes free\n", (mem_size - (long) _psp + 1L) * 16L);
   printf("\n  Next program will load at %04X:0000 hex\n",_psp);
}

