PROGRAM Free;
{ Written for Turbo Pascal 5.5 and Quick Pascal 1.0}

USES
   DOS;
VAR
   regs : Registers;
   Drive: INTEGER;
   DriveName: STRING;

PROCEDURE GetDefaultDrive;
   BEGIN
      regs.AH := $19;
      MsDos( regs );
      drive := regs.AL + 1
   END;

PROCEDURE GetDriveInfo;
   VAR ClusterSize, TotalBytes, FreeBytes : LongInt;
   BEGIN
      regs.AH := $36;
      regs.DL := drive;
      MsDos ( regs );
      IF( regs.AX = $FFFF ) THEN
         Writeln( 'Invalid Drive' )
      ELSE
         BEGIN
         ClusterSize := regs.AX * regs.CX ;
         TotalBytes  := regs.DX * ClusterSize;
         FreeBytes   := regs.BX * ClusterSize;
         Writeln('Drive: ',Chr(Drive + Ord('A') - 1));
         Writeln('   ', TotalBytes:9, ' bytes total disk space');
         Writeln('   ', FreeBytes:9,  ' bytes available on disk');
         Writeln;
         END;
   END;

FUNCTION HexString( value:WORD) : STRING;
   CONST
      Hextbl : ARRAY[0..15] OF Char = '0123456789ABCDEF';
   VAR
      TempString : STRING;
      n: Integer;
   BEGIN
      TempString := '';
      FOR n := 1 to 4 DO BEGIN
         TempString := Hextbl[value AND $F] + TempString;
         Value := Value SHR 4;
      END;
      HexString := TempString;
   END;

PROCEDURE GetMemoryInfo;
   VAR
      MemSize, TotalMem, FreeMem : LongInt;
      PSP : WORD;
   BEGIN
      regs.AH := $62;
      MsDos( regs );
      PSP := regs.BX;
      Intr($12, regs);
      MemSize := regs.AX * 64;
      TotalMem := MemSize * 16;
      FreeMem  := (MemSize - PSP + 1) * 16;
      Writeln('   ', TotalMem:9, ' bytes total memory');
      Writeln('   ', FreeMem:9,  ' bytes free');
      Writeln;
      Writeln('   Next program will load at ',HexString(PSP),':0000');
   END;

BEGIN          {Program Starts Here}
   IF ( ParamCount = 0) THEN
      GetDefaultDrive
   ELSE
      BEGIN
      DriveName := ParamStr(1);
         IF (DriveName[2] = ':') THEN
            Drive := Ord(UpCase(DriveName[1])) - Ord('A') + 1
         ELSE
            Drive := -1;
      END;
   GetDriveInfo;
   GetMemoryInfo;
END.
